using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {

        public static void Main()
        {
            CategoryBuilder.Create("Barotrauma", "Barotrauma", ModAPI.LoadSprite("icon.png"));

            //Generic Clothes
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Default Clothes",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "The default human model with no special job clothes.",
                    CategoryOverride = ModAPI.FindCategory("Barotrauma"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/defaultclothes.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprites/defaultclothesskin.png");
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        var bone = ModAPI.LoadTexture("sprites/skele.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            //Assistant
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Assistant",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "The basic job, does everything decently. Best for new players.",
                    CategoryOverride = ModAPI.FindCategory("Barotrauma"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/assistant.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprites/assistantskin.png");
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        var bone = ModAPI.LoadTexture("sprites/skele.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            //Captain
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Captain",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "The man in charge of piloting the ship and giving out orders. But not anything else. And also maybe some screaming at your peers.",
                    CategoryOverride = ModAPI.FindCategory("Barotrauma"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/captain.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprites/captainskin.png");
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        var bone = ModAPI.LoadTexture("sprites/skele.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var head = Instance.transform.Find("Head");
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var hatObject = new GameObject("hat");
                        hatObject.transform.SetParent(head);
                        hatObject.transform.localPosition = new Vector3(0, 0f);
                        hatObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        hatObject.transform.localScale = new Vector3(1.15f, 1.1f);
                        var hatSprite = hatObject.AddComponent<SpriteRenderer>();
                        hatSprite.sprite = ModAPI.LoadSprite("sprites/captainhat.png");
                        hatSprite.sortingLayerName = "Top";
                    }
                }
            );
            //Engineer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Engineer",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "Manages the reactor, and manages power wiring.",
                    CategoryOverride = ModAPI.FindCategory("Barotrauma"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/engineer.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprites/engineerskin.png");
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        var bone = ModAPI.LoadTexture("sprites/skele.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var head = Instance.transform.Find("Head");
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var hatObject = new GameObject("headset");
                        hatObject.transform.SetParent(head);
                        hatObject.transform.localPosition = new Vector3(0, 0f);
                        hatObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        hatObject.transform.localScale = new Vector3(1f, 1f);
                        var hatSprite = hatObject.AddComponent<SpriteRenderer>();
                        hatSprite.sprite = ModAPI.LoadSprite("sprites/engineerhelmet.png");
                        hatSprite.sortingLayerName = "Top";
                    }
                }
            );
            //Clown
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Clown",
                    NameToOrderByOverride = "Human2",
                    DescriptionOverride = "Everybody loves a clown!",
                    CategoryOverride = ModAPI.FindCategory("Barotrauma"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprites/clown.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprites/clownskin.png");
                        var flesh = ModAPI.LoadTexture("sprites/flesh.png");
                        var bone = ModAPI.LoadTexture("sprites/skele.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                        var head = Instance.transform.Find("Head");
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var hatObject = new GameObject("clownmask");
                        hatObject.transform.SetParent(head);
                        hatObject.transform.localPosition = new Vector3(-0.07f, 0.07f);
                        hatObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        hatObject.transform.localScale = new Vector3(1.1f, 1.1f);
                        var hatSprite = hatObject.AddComponent<SpriteRenderer>();
                        hatSprite.sprite = ModAPI.LoadSprite("sprites/clownmask.png");
                        hatSprite.sortingLayerName = "Top";
                    }
                }
            );
        }
    }
}